searchNodes=[{"doc":"A collection of helper utility modules and functions.","ref":"Euclid.html","title":"Euclid","type":"module"},{"doc":"Some ExUnit assertions","ref":"Euclid.Assertions.html","title":"Euclid.Assertions","type":"module"},{"doc":"","ref":"Euclid.Assertions.html#assert_datetime_approximate/3","title":"Euclid.Assertions.assert_datetime_approximate/3","type":"function"},{"doc":"Asserts that the left and right values are equal. Returns the left value unless the assertion fails, or if the :returning option is used. Uses assert left == right under the hood, but works nicely in a pipeline. Options: ignore_order: boolean - if the left and right values are lists, ignores the order when checking equality. returning: value - returns value if the assertion passes, rather than returning the left value. within: delta - asserts that the left and right values are within delta of each other rather than strictly equal. within: {delta, time_unit} - like within: delta but performs time comparisons in the specified time_unit . If left and right are strings, they are parsed as ISO8601 dates.","ref":"Euclid.Assertions.html#assert_eq/3","title":"Euclid.Assertions.assert_eq/3","type":"function"},{"doc":"Asserts that a NaiveDateTime or DateTime is no more than 30 seconds ago.","ref":"Euclid.Assertions.html#assert_recent/1","title":"Euclid.Assertions.assert_recent/1","type":"function"},{"doc":"Asserts a pre-condition and a post-condition are true after performing an action. Examples { :ok , agent } = Agent . start ( fn -&gt; 0 end ) assert_that ( Agent . update ( agent , fn s -&gt; s + 1 end ) , changes : Agent . get ( agent , fn s -&gt; s end ) , from : 0 , to : 1 )","ref":"Euclid.Assertions.html#assert_that/2","title":"Euclid.Assertions.assert_that/2","type":"macro"},{"doc":"","ref":"Euclid.Assertions.html#t:assert_eq_opts/0","title":"Euclid.Assertions.assert_eq_opts/0","type":"type"},{"doc":"Atom-related functions","ref":"Euclid.Atom.html","title":"Euclid.Atom","type":"module"},{"doc":"When given a string, converts it to an atom via String.to_atom/1 . When given an atom, returns it unchanged. Useful when you aren't sure ahead of time whether you have a string or an atom and want an atom.","ref":"Euclid.Atom.html#from_string/1","title":"Euclid.Atom.from_string/1","type":"function"},{"doc":"When given an atom, converts it to a string via Atom.to_string/1 . When given a string, returns it unchanged. Useful when you aren't sure ahead of time whether you have a string or an atom and want a string.","ref":"Euclid.Atom.html#to_string/1","title":"Euclid.Atom.to_string/1","type":"function"},{"doc":"DateTime-related functions","ref":"Euclid.DateTime.html","title":"Euclid.DateTime","type":"module"},{"doc":"Like DateTime.from_iso8601/1 but raises if the string cannot be parsed.","ref":"Euclid.DateTime.html#from_iso8601!/1","title":"Euclid.DateTime.from_iso8601!/1","type":"function"},{"doc":"Like DateTime.to_iso8601/1 but rounds to the nearest second first.","ref":"Euclid.DateTime.html#to_iso8601/2","title":"Euclid.DateTime.to_iso8601/2","type":"function"},{"doc":"","ref":"Euclid.Difference.html","title":"Euclid.Difference","type":"protocol"},{"doc":"Returns the difference between a and b . The fallback implementation uses Kernel.-/2 to subtract b from a .","ref":"Euclid.Difference.html#diff/2","title":"Euclid.Difference.diff/2","type":"function"},{"doc":"","ref":"Euclid.Difference.html#t:t/0","title":"Euclid.Difference.t/0","type":"type"},{"doc":"A duration is a {time, unit} tuple, where the time is a number and the unit is one of: :nanosecond , :microsecond , :millisecond , :second , :minute , :hour , :day","ref":"Euclid.Duration.html","title":"Euclid.Duration","type":"module"},{"doc":"Converts a {duration, time_unit} tuple into a numeric duration. Rounds down to the nearest whole number. Uses System.convert_time_unit/3 under the hood; see its documentation for more details. Examples iex&gt; Euclid.Duration . convert ( { 121 , :second } , :minute ) 2","ref":"Euclid.Duration.html#convert/2","title":"Euclid.Duration.convert/2","type":"function"},{"doc":"Converts a {duration, time_unit} tuple into a string. Examples iex&gt; Euclid.Duration . to_string ( { 1 , :second } ) &quot;1 second&quot; iex&gt; Euclid.Duration . to_string ( { 25 , :millisecond } ) &quot;25 milliseconds&quot;","ref":"Euclid.Duration.html#to_string/1","title":"Euclid.Duration.to_string/1","type":"function"},{"doc":"","ref":"Euclid.Duration.html#t:duration/0","title":"Euclid.Duration.duration/0","type":"type"},{"doc":"","ref":"Euclid.Duration.html#t:time_unit/0","title":"Euclid.Duration.time_unit/0","type":"type"},{"doc":"Enum-related functions","ref":"Euclid.Enum.html","title":"Euclid.Enum","type":"module"},{"doc":"","ref":"Euclid.Enum.html#any_present?/1","title":"Euclid.Enum.any_present?/1","type":"function"},{"doc":"","ref":"Euclid.Enum.html#at!/2","title":"Euclid.Enum.at!/2","type":"function"},{"doc":"","ref":"Euclid.Enum.html#compact/1","title":"Euclid.Enum.compact/1","type":"function"},{"doc":"","ref":"Euclid.Enum.html#fetch_multiple/2","title":"Euclid.Enum.fetch_multiple/2","type":"function"},{"doc":"","ref":"Euclid.Enum.html#filter_present/1","title":"Euclid.Enum.filter_present/1","type":"function"},{"doc":"","ref":"Euclid.Enum.html#find_indices/2","title":"Euclid.Enum.find_indices/2","type":"function"},{"doc":"","ref":"Euclid.Enum.html#first!/1","title":"Euclid.Enum.first!/1","type":"function"},{"doc":"","ref":"Euclid.Enum.html#isort/1","title":"Euclid.Enum.isort/1","type":"function"},{"doc":"","ref":"Euclid.Enum.html#isort_by/2","title":"Euclid.Enum.isort_by/2","type":"function"},{"doc":"","ref":"Euclid.Enum.html#join_present/2","title":"Euclid.Enum.join_present/2","type":"function"},{"doc":"","ref":"Euclid.Enum.html#pluck/2","title":"Euclid.Enum.pluck/2","type":"function"},{"doc":"","ref":"Euclid.Enum.html#tids/1","title":"Euclid.Enum.tids/1","type":"function"},{"doc":"","ref":"Euclid.Enum.html#update_or_append_by/3","title":"Euclid.Enum.update_or_append_by/3","type":"function"},{"doc":"Deprecated. Use Euclid.Sugar instead.","ref":"Euclid.Extra.Tuple.html","title":"Euclid.Extra.Tuple","type":"module"},{"doc":"","ref":"Euclid.Extra.Tuple.html#error/1","title":"Euclid.Extra.Tuple.error/1","type":"function"},{"doc":"","ref":"Euclid.Extra.Tuple.html#ok/1","title":"Euclid.Extra.Tuple.ok/1","type":"function"},{"doc":"File-related functions","ref":"Euclid.File.html","title":"Euclid.File","type":"module"},{"doc":"Returns a path to a new temp file in a new temp directory.","ref":"Euclid.File.html#new_tempfile_path/1","title":"Euclid.File.new_tempfile_path/1","type":"function"},{"doc":"Writes contents to a new temp file with extension file_extension , and returns the path to the file.","ref":"Euclid.File.html#write_tempfile/2","title":"Euclid.File.write_tempfile/2","type":"function"},{"doc":"Deprecated. Use Euclid.Random instead.","ref":"Euclid.Integer.html","title":"Euclid.Integer","type":"module"},{"doc":"","ref":"Euclid.Integer.html#rand/1","title":"Euclid.Integer.rand/1","type":"function"},{"doc":"List-related functions","ref":"Euclid.List.html","title":"Euclid.List","type":"module"},{"doc":"","ref":"Euclid.List.html#compact/1","title":"Euclid.List.compact/1","type":"function"},{"doc":"","ref":"Euclid.List.html#first/2","title":"Euclid.List.first/2","type":"function"},{"doc":"","ref":"Euclid.List.html#first_present/1","title":"Euclid.List.first_present/1","type":"function"},{"doc":"returns the only item in the list; raises if there are no items or more than 1 item","ref":"Euclid.List.html#only!/1","title":"Euclid.List.only!/1","type":"function"},{"doc":"","ref":"Euclid.List.html#sorted?/1","title":"Euclid.List.sorted?/1","type":"function"},{"doc":"Map-related functions","ref":"Euclid.Map.html","title":"Euclid.Map","type":"module"},{"doc":"","ref":"Euclid.Map.html#all_values_blank?/1","title":"Euclid.Map.all_values_blank?/1","type":"function"},{"doc":"","ref":"Euclid.Map.html#atomize_keys/1","title":"Euclid.Map.atomize_keys/1","type":"function"},{"doc":"","ref":"Euclid.Map.html#deep_atomize_keys/1","title":"Euclid.Map.deep_atomize_keys/1","type":"function"},{"doc":"","ref":"Euclid.Map.html#merge/2","title":"Euclid.Map.merge/2","type":"function"},{"doc":"","ref":"Euclid.Map.html#rename_key/2","title":"Euclid.Map.rename_key/2","type":"function"},{"doc":"","ref":"Euclid.Map.html#rename_key/3","title":"Euclid.Map.rename_key/3","type":"function"},{"doc":"","ref":"Euclid.Map.html#rename_keys/2","title":"Euclid.Map.rename_keys/2","type":"function"},{"doc":"","ref":"Euclid.Map.html#stringify_keys/1","title":"Euclid.Map.stringify_keys/1","type":"function"},{"doc":"","ref":"Euclid.Map.html#transform/3","title":"Euclid.Map.transform/3","type":"function"},{"doc":"Generate random data.","ref":"Euclid.Random.html","title":"Euclid.Random","type":"module"},{"doc":"Returns a random integer between 0 and max","ref":"Euclid.Random.html#integer/1","title":"Euclid.Random.integer/1","type":"function"},{"doc":"Returns a base64- or base32-encoded random string of 32 characters. See Euclid.Random.string/2 .","ref":"Euclid.Random.html#string/1","title":"Euclid.Random.string/1","type":"function"},{"doc":"Returns a base64- or base32-encoded random string of given length Examples iex&gt; Euclid.Random . string ( ) &quot;Sr/y4m/YiVSJcIgI5lG+76vMfaZ7KZ7c&quot; iex&gt; Euclid.Random . string ( 5 ) &quot;9pJrK&quot; iex&gt; Euclid.Random . string ( 5 , :base32 ) &quot;AC53Z&quot;","ref":"Euclid.Random.html#string/2","title":"Euclid.Random.string/2","type":"function"},{"doc":"","ref":"Euclid.Random.html#t:encoding/0","title":"Euclid.Random.encoding/0","type":"type"},{"doc":"String-related functions","ref":"Euclid.String.html","title":"Euclid.String","type":"module"},{"doc":"","ref":"Euclid.String.html#dasherize/1","title":"Euclid.String.dasherize/1","type":"function"},{"doc":"","ref":"Euclid.String.html#inner_truncate/2","title":"Euclid.String.inner_truncate/2","type":"function"},{"doc":"Compares the two binaries in constant-time to avoid timing attacks. See: http://codahale.com/a-lesson-in-timing-attacks/","ref":"Euclid.String.html#secure_compare/2","title":"Euclid.String.secure_compare/2","type":"function"},{"doc":"","ref":"Euclid.String.html#squish/1","title":"Euclid.String.squish/1","type":"function"},{"doc":"","ref":"Euclid.String.html#surround/2","title":"Euclid.String.surround/2","type":"function"},{"doc":"","ref":"Euclid.String.html#surround/3","title":"Euclid.String.surround/3","type":"function"},{"doc":"","ref":"Euclid.String.html#to_integer/1","title":"Euclid.String.to_integer/1","type":"function"},{"doc":"","ref":"Euclid.String.html#to_integer/2","title":"Euclid.String.to_integer/2","type":"function"},{"doc":"","ref":"Euclid.String.html#trim/1","title":"Euclid.String.trim/1","type":"function"},{"doc":"","ref":"Euclid.String.html#truncate_at/3","title":"Euclid.String.truncate_at/3","type":"function"},{"doc":"","ref":"Euclid.String.html#underscore/1","title":"Euclid.String.underscore/1","type":"function"},{"doc":"Some common syntactic sugar functions. These functions are intended to be used by importing the functions or the whole module: import Euclid.Sugar , only : [ noreply : 1 ] def handle_event ( &quot;foo&quot; , _params , socket ) do socket |&gt; assign ( foo : &quot;bar&quot; ) |&gt; noreply ( ) end","ref":"Euclid.Sugar.html","title":"Euclid.Sugar","type":"module"},{"doc":"Wraps a term in an :error tuple. Useful in pipelines. Examples iex&gt; %{ } |&gt; Map . put ( :count , &quot;unknown&quot; ) |&gt; Euclid.Sugar . error ( ) { :error , %{ count : &quot;unknown&quot; } }","ref":"Euclid.Sugar.html#error/1","title":"Euclid.Sugar.error/1","type":"function"},{"doc":"Unwraps an :error tuple, raising if the term is not an :error tuple Examples iex&gt; { :error , 1 } |&gt; Euclid.Sugar . error! ( ) 1","ref":"Euclid.Sugar.html#error!/1","title":"Euclid.Sugar.error!/1","type":"function"},{"doc":"Wraps a term in a :noreply tuple Examples iex&gt; %{ } |&gt; Map . put ( :count , 0 ) |&gt; Euclid.Sugar . noreply ( ) { :noreply , %{ count : 0 } }","ref":"Euclid.Sugar.html#noreply/1","title":"Euclid.Sugar.noreply/1","type":"function"},{"doc":"Wraps a term in an :ok tuple Examples iex&gt; %{ } |&gt; Map . put ( :count , 10 ) |&gt; Euclid.Sugar . ok ( ) { :ok , %{ count : 10 } }","ref":"Euclid.Sugar.html#ok/1","title":"Euclid.Sugar.ok/1","type":"function"},{"doc":"Unwraps an :ok tuple, raising if the term is not an :ok tuple Examples iex&gt; { :ok , 1 } |&gt; Euclid.Sugar . ok! ( ) 1","ref":"Euclid.Sugar.html#ok!/1","title":"Euclid.Sugar.ok!/1","type":"function"},{"doc":"Accepts two arguments and returns the second. Useful at the end of the pipeline when you want to return a different value than the last result of the pipeline, such as when the pipeline has side effects and you want to return a different value and you feel the code will be easier to read if everything is in a pipeline. Examples iex&gt; %{ } |&gt; Map . put ( :count , 20 ) |&gt; Euclid.Sugar . returning ( :count_updated ) :count_updated","ref":"Euclid.Sugar.html#returning/2","title":"Euclid.Sugar.returning/2","type":"function"},{"doc":"Extra functions for terms.","ref":"Euclid.Term.html","title":"Euclid.Term","type":"module"},{"doc":"Returns true if the term is blank, nil, or empty","ref":"Euclid.Term.html#blank?/1","title":"Euclid.Term.blank?/1","type":"function"},{"doc":"Returns value unless it is blank, in which case it returns default","ref":"Euclid.Term.html#or_default/2","title":"Euclid.Term.or_default/2","type":"function"},{"doc":"Returns the value if it is present (via present? ), or else returns the default value","ref":"Euclid.Term.html#presence/2","title":"Euclid.Term.presence/2","type":"function"},{"doc":"Returns true if the term is not blank, nil, or empty","ref":"Euclid.Term.html#present?/1","title":"Euclid.Term.present?/1","type":"function"},{"doc":"","ref":"Euclid.Exists.html","title":"Euclid.Exists","type":"module"},{"doc":"","ref":"Euclid.Exists.html#any?/1","title":"Euclid.Exists.any?/1","type":"function"},{"doc":"","ref":"Euclid.Exists.html#blank?/1","title":"Euclid.Exists.blank?/1","type":"function"},{"doc":"","ref":"Euclid.Exists.html#filter/1","title":"Euclid.Exists.filter/1","type":"function"},{"doc":"","ref":"Euclid.Exists.html#first_present/1","title":"Euclid.Exists.first_present/1","type":"function"},{"doc":"","ref":"Euclid.Exists.html#join/2","title":"Euclid.Exists.join/2","type":"function"},{"doc":"","ref":"Euclid.Exists.html#or_default/2","title":"Euclid.Exists.or_default/2","type":"function"},{"doc":"","ref":"Euclid.Exists.html#presence/1","title":"Euclid.Exists.presence/1","type":"function"},{"doc":"","ref":"Euclid.Exists.html#present?/1","title":"Euclid.Exists.present?/1","type":"function"},{"doc":"","ref":"Euclid.Extra.Atom.html","title":"Euclid.Extra.Atom","type":"module"},{"doc":"","ref":"Euclid.Extra.Atom.html#from_string/1","title":"Euclid.Extra.Atom.from_string/1","type":"function"},{"doc":"","ref":"Euclid.Extra.Atom.html#to_string/1","title":"Euclid.Extra.Atom.to_string/1","type":"function"},{"doc":"","ref":"Euclid.Extra.DateTime.html","title":"Euclid.Extra.DateTime","type":"module"},{"doc":"","ref":"Euclid.Extra.DateTime.html#to_iso8601/2","title":"Euclid.Extra.DateTime.to_iso8601/2","type":"function"},{"doc":"","ref":"Euclid.Extra.Enum.html","title":"Euclid.Extra.Enum","type":"module"},{"doc":"","ref":"Euclid.Extra.Enum.html#at!/2","title":"Euclid.Extra.Enum.at!/2","type":"function"},{"doc":"","ref":"Euclid.Extra.Enum.html#compact/1","title":"Euclid.Extra.Enum.compact/1","type":"function"},{"doc":"","ref":"Euclid.Extra.Enum.html#fetch_multiple/2","title":"Euclid.Extra.Enum.fetch_multiple/2","type":"function"},{"doc":"","ref":"Euclid.Extra.Enum.html#find_indices/2","title":"Euclid.Extra.Enum.find_indices/2","type":"function"},{"doc":"","ref":"Euclid.Extra.Enum.html#first!/1","title":"Euclid.Extra.Enum.first!/1","type":"function"},{"doc":"","ref":"Euclid.Extra.Enum.html#isort/1","title":"Euclid.Extra.Enum.isort/1","type":"function"},{"doc":"","ref":"Euclid.Extra.Enum.html#isort_by/2","title":"Euclid.Extra.Enum.isort_by/2","type":"function"},{"doc":"","ref":"Euclid.Extra.Enum.html#pluck/2","title":"Euclid.Extra.Enum.pluck/2","type":"function"},{"doc":"","ref":"Euclid.Extra.Enum.html#tids/1","title":"Euclid.Extra.Enum.tids/1","type":"function"},{"doc":"","ref":"Euclid.Extra.Enum.html#update_or_append_by/3","title":"Euclid.Extra.Enum.update_or_append_by/3","type":"function"},{"doc":"","ref":"Euclid.Extra.Integer.html","title":"Euclid.Extra.Integer","type":"module"},{"doc":"","ref":"Euclid.Extra.Integer.html#rand/1","title":"Euclid.Extra.Integer.rand/1","type":"function"},{"doc":"","ref":"Euclid.Extra.List.html","title":"Euclid.Extra.List","type":"module"},{"doc":"","ref":"Euclid.Extra.List.html#compact/1","title":"Euclid.Extra.List.compact/1","type":"function"},{"doc":"","ref":"Euclid.Extra.List.html#first/2","title":"Euclid.Extra.List.first/2","type":"function"},{"doc":"returns the only item in the list; raises if there are no items or more than 1 item","ref":"Euclid.Extra.List.html#only!/1","title":"Euclid.Extra.List.only!/1","type":"function"},{"doc":"","ref":"Euclid.Extra.List.html#sorted?/1","title":"Euclid.Extra.List.sorted?/1","type":"function"},{"doc":"","ref":"Euclid.Extra.Map.html","title":"Euclid.Extra.Map","type":"module"},{"doc":"","ref":"Euclid.Extra.Map.html#all_values_blank?/1","title":"Euclid.Extra.Map.all_values_blank?/1","type":"function"},{"doc":"","ref":"Euclid.Extra.Map.html#atomize_keys/1","title":"Euclid.Extra.Map.atomize_keys/1","type":"function"},{"doc":"","ref":"Euclid.Extra.Map.html#deep_atomize_keys/1","title":"Euclid.Extra.Map.deep_atomize_keys/1","type":"function"},{"doc":"","ref":"Euclid.Extra.Map.html#merge/2","title":"Euclid.Extra.Map.merge/2","type":"function"},{"doc":"","ref":"Euclid.Extra.Map.html#rename_key/2","title":"Euclid.Extra.Map.rename_key/2","type":"function"},{"doc":"","ref":"Euclid.Extra.Map.html#rename_key/3","title":"Euclid.Extra.Map.rename_key/3","type":"function"},{"doc":"","ref":"Euclid.Extra.Map.html#rename_keys/2","title":"Euclid.Extra.Map.rename_keys/2","type":"function"},{"doc":"","ref":"Euclid.Extra.Map.html#stringify_keys/1","title":"Euclid.Extra.Map.stringify_keys/1","type":"function"},{"doc":"","ref":"Euclid.Extra.Map.html#transform/3","title":"Euclid.Extra.Map.transform/3","type":"function"},{"doc":"Helpers for generating random data in whatever format","ref":"Euclid.Extra.Random.html","title":"Euclid.Extra.Random","type":"module"},{"doc":"Returns a base64 encoded string of given length Examples iex&gt; Euclid.Extra.Random . string ( ) &quot;Sr/y4m/YiVSJcIgI5lG+76vMfaZ7KZ7c&quot; iex&gt; Euclid.Extra.Random . string ( 5 ) &quot;9pJrK&quot;","ref":"Euclid.Extra.Random.html#string/1","title":"Euclid.Extra.Random.string/1","type":"function"},{"doc":"","ref":"Euclid.Extra.String.html","title":"Euclid.Extra.String","type":"module"},{"doc":"","ref":"Euclid.Extra.String.html#dasherize/1","title":"Euclid.Extra.String.dasherize/1","type":"function"},{"doc":"","ref":"Euclid.Extra.String.html#inner_truncate/2","title":"Euclid.Extra.String.inner_truncate/2","type":"function"},{"doc":"Compares the two binaries in constant-time to avoid timing attacks. See: http://codahale.com/a-lesson-in-timing-attacks/","ref":"Euclid.Extra.String.html#secure_compare/2","title":"Euclid.Extra.String.secure_compare/2","type":"function"},{"doc":"","ref":"Euclid.Extra.String.html#squish/1","title":"Euclid.Extra.String.squish/1","type":"function"},{"doc":"","ref":"Euclid.Extra.String.html#surround/2","title":"Euclid.Extra.String.surround/2","type":"function"},{"doc":"","ref":"Euclid.Extra.String.html#surround/3","title":"Euclid.Extra.String.surround/3","type":"function"},{"doc":"","ref":"Euclid.Extra.String.html#to_integer/1","title":"Euclid.Extra.String.to_integer/1","type":"function"},{"doc":"","ref":"Euclid.Extra.String.html#to_integer/2","title":"Euclid.Extra.String.to_integer/2","type":"function"},{"doc":"","ref":"Euclid.Extra.String.html#trim/1","title":"Euclid.Extra.String.trim/1","type":"function"},{"doc":"","ref":"Euclid.Extra.String.html#truncate_at/3","title":"Euclid.Extra.String.truncate_at/3","type":"function"},{"doc":"","ref":"Euclid.Extra.String.html#underscore/1","title":"Euclid.Extra.String.underscore/1","type":"function"},{"doc":"","ref":"Euclid.Test.Extra.Assertions.html","title":"Euclid.Test.Extra.Assertions","type":"module"},{"doc":"","ref":"Euclid.Test.Extra.Assertions.html#assert_datetime_approximate/3","title":"Euclid.Test.Extra.Assertions.assert_datetime_approximate/3","type":"function"},{"doc":"","ref":"Euclid.Test.Extra.Assertions.html#assert_eq/3","title":"Euclid.Test.Extra.Assertions.assert_eq/3","type":"function"},{"doc":"","ref":"Euclid.Test.Extra.Assertions.html#assert_recent/1","title":"Euclid.Test.Extra.Assertions.assert_recent/1","type":"function"},{"doc":"","ref":"Euclid.Test.Extra.Assertions.html#assert_that/2","title":"Euclid.Test.Extra.Assertions.assert_that/2","type":"macro"},{"doc":"Euclid is a collection of helper utility modules and functions. The code is free for all to use and reuse, as a whole or piecemeal. Specifically, if you only want a function or two, consider copying the code to your own codebase rather than introducing Euclid as a dependency. You don't need to mention the source either.","ref":"readme.html","title":"Euclid — Tools for Geometers","type":"extras"},{"doc":"Repo: https://github.com/geometerio/euclid Docs: https://hexdocs.pm/euclid/Euclid.html CI: Coming soon!","ref":"readme.html#resources","title":"Euclid — Tools for Geometers - Resources","type":"extras"},{"doc":"Add to mix.exs : { :euclid , &quot;~&gt; 0.2.5&quot; }","ref":"readme.html#installation","title":"Euclid — Tools for Geometers - Installation","type":"extras"},{"doc":"As of version 0.2.5 , the Euclid.Extra.* and Euclid.Test.Extra.* modules are deprecated. Use the modules in Euclid instead (for example, Euclid.String instead of the deprecated Euclid.Extra.String ). Some other functions are deprecated too. See the changelog for details. Deprecated functions and modules will be removed in the upcoming 1.0 release.","ref":"readme.html#upgrading","title":"Euclid — Tools for Geometers - Upgrading","type":"extras"},{"doc":"Getting started After cloning this repo, run bin/dev/doctor . If it finds a problem, it will suggest a remedy, which it will put in the clipboard. If you think the remedy will work well on your computer, paste it into your terminal. You can also try a different remedy -- doctor is not omnipotent. Then run doctor over and over until it succeeds. (Note: doctor may not work well on Windows.) Day to day development Get new commits with bin/dev/update . Make changes and run bin/dev/test to make sure everything works. Please add new tests for new functionality. Run bin/dev/shipit when you're ready to ship. Running a local version of Euclid in a local version of your application # In YOUR APPLICATION&#39;s mix.exs: def deps do [ local_or_remote ( :remote , :euclid , version : &quot;~&gt; 0.2&quot; , path : &quot;../euclid&quot; ) ] end defp local_or_remote ( :local , package , options ) do { package , options |&gt; Keyword . delete ( :organization ) |&gt; Keyword . delete ( :version ) } end defp local_or_remote ( :remote , package , options ) do { package , options |&gt; Keyword . get ( :version ) , options |&gt; Keyword . delete ( :path ) |&gt; Keyword . delete ( :version ) } end Publishing a new version of Euclid Increment the version (in VERSION ) following Semantic Versioning . Commit the version file and push using bin/dev/shipit Coming soon: CI will run tests, and if tests pass, it will publish a new patch version in Hex. Publish the new Hex package version: mix hex.publish package (include package to avoid publishing the docs, which are still too ugly to publish). Once the new version is published: Change :local back to :remote in your application's mix.exs Run mix deps.update euclid in your application to get the latest version.","ref":"readme.html#development-of-euclid-itself","title":"Euclid — Tools for Geometers - Development (of Euclid itself)","type":"extras"},{"doc":"Copyright © 2020-2022 Geometer, LLC. See also License","ref":"readme.html#copyright-and-license","title":"Euclid — Tools for Geometers - Copyright and license","type":"extras"},{"doc":"geometer : a specialist in geometry Euclid : the father of geometry","ref":"readme.html#random","title":"Euclid — Tools for Geometers - Random","type":"extras"}]